
// Demonstrationsbeispiel fr alternative Anzeigemglichkeiten an einem zweizeiligen Text-LCD mittels Sonderzeichendefinition
// Anzeigearten: Normal, Fett (eine Ziffer ber zwei Zeichen, Siebensegment am LCD (normal, fett)
// Autor: A. Scheibelmasser, CAMPUS 02


	#include <reg517a.h> 	//Einbinden des Headerfiles, wo z.B P4 definiert ist
#include <stdio.h>
#include "my_lcd.h"			//Arbeitsverzeichnis mit Definitionen der LCD-Routinen
#include <math.h>

code float					// Koeffizienten fr die Temp.-Berechnung des NTC
 	r_ref = 4990,
	a= 0.0012814814,
	b= 0.000236678791,
	c= 0.0000000908736406;

int sekunde=0,minute=0,stunde=0,zaehler,adu; // Variablen Uhrzeitberechnung
char buffer[21];							 // Buffer LCD Ausgabe
float r_temp,lnr,temp; 						 // Hilfsvariablen Temperaturberechnung NTC


void zeit_int(void) interrupt 1	//  Timer 0 Interruptfunktion 
{
	TH0=0x3C;	// Timer Reload 50 ms
	TL0=0xAF;
	zaehler++;	

	if (zaehler==20) {sekunde++;zaehler=0;} // Umrechnung sek. min. 
	if (sekunde==60) {minute++;sekunde=0;} 
	if (minute==60)  {stunde++;minute=0;} 
	if (stunde==24)  {stunde=0;} 
}

int aduwert(char kanal)		// ADC Start, Auswertung
{
unsigned int low,high;				

ADCON1=kanal;						// ADC Kanal festlegen 0-11
ADDATL = 0;							// Schreibzugriff auf ADDTAL startet Umsetzung
while(BSY)	{;}						// Warte bis BSY Flag Null wird ( Bit 5  in ADCON0 )
low  = ADDATL >> 6;					// ADDATL.7,ADDATL.6 (D1,D0) an Position 1 und 0 schieben
high = ADDATH << 2;					// ADDATH.7 bis ADDATH.0 (D9-D2) an Position 9 bis 2 schieben
return(high+low);
 
}

main ()
  {

   	TMOD = 0x01;// Timer 0 16 Bit
	TR0  = 1;   // Timer Start
	ET0  = 1;   // Timer INT ein
	EAL= 1;	    // Enable ALL INTs
 
	init_lcd();  	//Display Initialisieren und Lschen 
	

	while (1)
	{
         	blank_lcd();
	       	sieben_segment_fett(); 	// Grafikzeichen fr Siebensegmentanzeige (fett) laden
 		    sprintf(buffer,"%02d:%02d:%02d",stunde,minute,sekunde);
			seg7_lcd_fett(3,buffer);		// Ausgabe Uhrzeit
            warte(5000);

			blank_lcd();
	       	sieben_segment(); 	// Grafikzeichen fr Siebensegmentanzeige (small) laden
 		    sprintf(buffer,"%02d:%02d:%02d",stunde,minute,sekunde);
			seg7_lcd(3,buffer);		// Ausgabe Uhrzeit
            warte(5000);
        
		    adu = aduwert(8);						// Einlesen Kanal 8 NTC
			r_temp = r_ref *adu/(1023-adu);			// Temperaturberechnung
			lnr = log(r_temp);
			temp= 1.0/(a+b*lnr+c*lnr*lnr*lnr);
			temp -=273.2;
			        
			blank_lcd();
			sieben_segment(); 	// Grafikzeichen fr Siebensegmentanzeige (small) laden
			sprintf (buffer,"%2.2f \337C ",temp);
	        seg7_lcd(3,buffer);	// Ausgabe Temperatur NTC
            warte(5000);

            blank_lcd();
            sieben_segment_fett(); 	// Grafikzeichen fr Siebensegmentanzeige (fett)laden
            seg7_lcd_fett(3,buffer);// Ausgabe Temperatur NTC
            warte(5000);

            blank_lcd();
			lcd_big(2,5,buffer);	// Ausgabe der Temperatur mittels eines dyn. zugewiesenen breitenen Fonts (Breite 2 Text-Zeichen)
            warte(5000);

            blank_lcd();
			print_lcd(2,5,buffer);	// Ausgabe der Temperatur mit dem Standardzeichensatz des LCD'S
            warte(5000);

	}
  }





